/*
 * MMXGstStream.h
 *
 *  Created on: Aug 20, 2013
 *      Author: mmxbuild
 */

#ifndef MMXGSTSTREAM_H_
#define MMXGSTSTREAM_H_

#include <string>
#include <gst/gst.h>
#include <glib.h>
#include <glib-object.h>
#include "Payload.h"



class MMXGstStream {
private:
	std::string name;
	std::string dstIp;
	int dstPort;
	int srcPort;
	int payload;
	Payload::Type payloadType;
	bool setupSuccess;

	guint bus_watch_id;

	GMainLoop* loop;
	GstElement* pipeline;
	GstElement* source;
	GstElement* demuxer;
	GstElement* encoder;
	GstElement* payloader;
	GstElement* sink;
	GstBus* bus;

public:
	MMXGstStream(std::string name, std::string dstIp, int dstPort, int srcPort, int payload, Payload::Type payloadType);
	void play(std::string file);
	void stop();
	virtual ~MMXGstStream();
	//gboolean bus_call(GstBus* bus, GstMessage* msg, gpointer data);
	//void on_pad_added(GstElement *element, GstPad *pad, gpointer data);



};

#endif /* MMXGSTSTREAM_H_ */
